Skip to content

# Advanced Server Installation

This section outlines installing the Netmaker server, including Netmaker, Netmaker UI, rqlite, and CoreDNS

## System Compatibility

Netmaker will require elevated privileges to perform network operations. Netmaker has similar limitations to netclient (client networking agent).

Typically, Netmaker is run inside of containers (Docker). To run a non-docker installation, you must run the Netmaker binary, CoreDNS binary, database, and a web server directly on the host. Each of these components have their own individual requirements.

The quick install guide is recommended for first-time installs.

The following documents are meant for special cases like Kubernetes and LXC, or for more advanced setups.

## Server Configuration Reference

Netmaker sets its configuration in the following order of precendence:

1. Defaults

2. Config File

3. Environment Variables

### Variable Description

VERBOSITY:

  Default: 0

  Description: Specify level of logging you would like on the server. Goes up to 3 for debugging.

GRPC_SSL:

  Default: “off”

  Description: Specifies if GRPC is going over secure GRPC or SSL. This is a setting for the clients and is passed through the access token. Can be set to “on” and “off”. Set to on if SSL is configured for GRPC.

SERVER_API_CONN_STRING

  Default: “”

  Description: Allows specification of the string used to connect to the server api. Format: IP:PORT or DOMAIN:PORT. Defaults to SERVER_HOST if not specified.

SERVER_GRPC_CONN_STRING

  Default: “”

  Description: Allows specification of the string used to connect to grpc. Format: IP:PORT or DOMAIN:PORT. Defaults to SERVER_HOST if not specified.

SERVER_HOST: (depreciated, use SERVER_API_CONN_STRING and SERVER_GRPC_CONN_STRING)

  Default: Server will perform an IP check and set automatically unless explicitly set, or DISABLE_REMOTE_IP_CHECK is set to true, in which case it defaults to 127.0.0.1

  Description: Sets the SERVER_HTTP_HOST and SERVER_GRPC_HOST variables if they are unset. The address where traffic comes in.

SERVER_HTTP_HOST: (depreciated, use SERVER_API_CONN_STRING and SERVER_GRPC_CONN_STRING)

  Default: Equals SERVER_HOST if set, “127.0.0.1” if SERVER_HOST is unset.

  Description: Set to make the HTTP and GRPC functions available via different interfaces/networks.

SERVER_GRPC_HOST: (depreciated, use SERVER_API_CONN_STRING and SERVER_GRPC_CONN_STRING)

  Default: Equals SERVER_HOST if set, “127.0.0.1” if SERVER_HOST is unset.

  Description: Set to make the HTTP and GRPC functions available via different interfaces/networks.

API_PORT:

  Default: 8081

  Description: The HTTP API port for Netmaker. Used for API calls / communication from front end.

GRPC_PORT:

  Default: 50051

  Description: The GRPC port for Netmaker. Used for communications from nodes.

MASTER_KEY:

  Default: “secretkey”

  Description: The admin master key for accessing the API. Change this in any production installation.

CORS_ALLOWED_ORIGIN:

  Default: “*”

  Description: The “allowed origin” for API requests. Change to restrict where API requests can come from.

REST_BACKEND:

  Default: “on”

  Description: Enables the REST backend (API running on API_PORT at SERVER_HTTP_HOST). Change to “off” to turn off.

AGENT_BACKEND:

  Default: “on”

  Description: Enables the AGENT backend (GRPC running on GRPC_PORT at SERVER_GRPC_HOST). Change to “off” to turn off.

DNS_MODE:

  Default: “off”

  Description: Enables DNS Mode, meaning config files will be generated for CoreDNS.

DATABASE:

  Default: “sqlite”

  Description: Specify db type to connect with. Currently, options include “sqlite”, “rqlite”, and “postgres”.

SQL_CONN:

  Default: “http://”

  Description: Specify the necessary string to connect with your local or remote sql database.

SQL_HOST:

  Default: “localhost”

  Description: Host where postgres is running.

SQL_PORT:

  Default: “5432”

  Description: port postgres is running.

SQL_DB:

  Default: “netmaker”

  Description: DB to use in postgres.

SQL_USER:

  Default: “postgres”

  Description: User for posgres.

SQL_PASS:

  Default: “nopass”

  Description: Password for postgres.

CLIENT_MODE:

  Default: “on”

  Description: Specifies if server should deploy itself as a node (client) in each network. May be turned to “off” for more restricted servers.

RCE:

  Default: “off”

  Description: The server enables you to set PostUp and PostDown commands for nodes, which is standard for WireGuard with wg-quick, but is also Remote Code Execution, which is a critical vulnerability if the server is exploited. Because of this, it’s turned off by default, but if turned on, PostUp and PostDown become editable.

SERVER_GRPC_WIREGUARD

  Depreciated: no longer in use

DISPLAY_KEYS

  Default: “on”

  Description: If “on”, will allow you to always show the key values of “access keys”. This could be considered a vulnerability, so if turned “off”, will only display key values once, and it is up to the users to store the key values locally.

NODE_ID

  Default: <system mac addres>

  Description: This setting is used for HA configurations of the server, to identify between different servers. Nodes are given ID’s like netmaker-1, netmaker-2, and netmaker-3. If the server is not HA, there is no reason to set this field.

TELEMETRY

  Default: “on”

  Description: If “on”, the server will send anonymous telemetry data once daily, which is used to improve the product. Data sent includes counts (integer values) for the number of nodes, types of nodes, users, and networks. It also sends the version of the server.

### Config File Reference

A config file may be placed under config/environments/<env-name>.yml. To read this file at runtime, provide the environment variable NETMAKER_ENV at runtime. For instance, dev.yml paired with ENV=dev. Netmaker will load the specified Config file. This allows you to store and manage configurations for different environments. Below is a reference Config File you may use.

    server:
      apihost: "" # defaults to 127.0.0.1 or remote ip (SERVER_HOST) if DisableRemoteIPCheck is not set to true. SERVER_API_HOST if set
      apiport: "" # defaults to 8081 or HTTP_PORT (if set)
      grpchost: "" # defaults to 127.0.0.1 or remote ip (SERVER_HOST) if DisableRemoteIPCheck is not set to true. SERVER_GRPC_HOST if set.
      grpcport: "" # defaults to 50051 or GRPC_PORT (if set)
      masterkey: "" # defaults to 'secretkey' or MASTER_KEY (if set)
      allowedorigin: "" # defaults to '*' or CORS_ALLOWED_ORIGIN (if set)
      restbackend: "" # defaults to "on" or REST_BACKEND (if set)
      agentbackend: "" # defaults to "on" or AGENT_BACKEND (if set)
      clientmode: "" # defaults to "on" or CLIENT_MODE (if set)
      dnsmode: "" # defaults to "on" or DNS_MODE (if set)
      sqlconn: "" # defaults to "http://" or SQL_CONN (if set)
      disableremoteipcheck: "" # defaults to "false" or DISABLE_REMOTE_IP_CHECK (if set)
      version: "" # version of server
      rce: "" # defaults to "off"

### Compose File - Annotated

All environment variables and options are enabled in this file. It is the equivalent to running the “full install” from the above section. However, all environment variables are included, and are set to the default values provided by Netmaker (if the environment variable was left unset, it would not change the installation). Comments are added to each option to show how you might use it to modify your installation.

    services:
      rqlite:
        container_name: rqlite
        image: rqlite/rqlite
        network_mode: host
        restart: always
        volumes:
          - sqldata:/rqlite/file/data
      netmaker: # The Primary Server for running Netmaker
        privileged: true # Necessary to run sudo/root level commands on host system. Take out if not running with CLIENT_MODE=on
        container_name: netmaker
        depends_on:
          - rqlite
        image: gravitl/netmaker:v0.9.4
        volumes: # Volume mounts necessary for CLIENT_MODE to control wireguard networking on host (except dnsconfig, which is where dns config files are stored for use by CoreDNS)
          - dnsconfig:/root/config/dnsconfig # Netmaker writes Corefile to this location, which gets mounted by CoreDNS for DNS configuration.
          - /usr/bin/wg:/usr/bin/wg
        cap_add: # Necessary for CLIENT_MODE. Should be removed if turned off.
          - NET_ADMIN
        restart: always
        network_mode: host # Necessary for CLIENT_MODE. Should be removed if turned off, but then need to add port mappings
        environment:
          SERVER_HOST: "" # All the Docker Compose files pre-populate this with HOST_IP, which you replace as part of the install instructions. This will set both HTTP and GRPC host.
          SERVER_HTTP_HOST: "127.0.0.1" # Overrides SERVER_HOST if set. Useful for making HTTP and GRPC available via different interfaces/networks.
          SERVER_GRPC_HOST: "127.0.0.1" # Overrides SERVER_HOST if set. Useful for making HTTP and GRPC available via different interfaces/networks.
          API_PORT: 8081 # The HTTP API port for Netmaker. Used for API calls / communication from front end. If changed, need to change port of BACKEND_URL for netmaker-ui.
          GRPC_PORT: 50051 # The GRPC port for Netmaker. Used for communications from nodes.
          CLIENT_MODE: "on" # on if netmaker should run its own client, off if not.
          MASTER_KEY: "secretkey" # The admin master key for accessing the API. Change this in any production installation.
          CORS_ALLOWED_ORIGIN: "*" # The "allowed origin" for API requests. Change to restrict where API requests can come from.
          REST_BACKEND: "on" # Enables the REST backend (API running on API_PORT at SERVER_HTTP_HOST). Change to "off" to turn off.
          AGENT_BACKEND: "on" # Enables the AGENT backend (GRPC running on GRPC_PORT at SERVER_GRPC_HOST). Change to "off" to turn off.
          DNS_MODE: "on" # Enables DNS Mode, meaning config files will be generated for CoreDNS. Note, turning "off" does not remove CoreDNS. You still need to remove CoreDNS from compose file.
          DISABLE_REMOTE_IP_CHECK: "off" # If turned "on", Server will not set Host based on remote IP check. This is already overridden if SERVER_HOST is set. Turned "off" by default.
          GRPC_SSL: "off" # Tells clients to use SSL to connect to GRPC. Switch to on to turn on.
          COREDNS_ADDR: "" # Address of the CoreDNS server. Defaults to SERVER_HOST
          DISPLAY_KEYS: "on" # Show keys permanently in UI (until deleted) as opposed to 1-time display.
          SERVER_API_CONN_STRING: "" # Changes the api connection string. IP:PORT format. By default is empty and uses SERVER_HOST:API_PORT
          SERVER_GRPC_CONN_STRING: "" # Changes the grpc connection string. IP:PORT format. By default is empty and uses SERVER_HOST:GRPC_PORT
          RCE: "off" # Enables setting PostUp and PostDown (arbitrary commands) on nodes from the server. Off by default.
          NODE_ID: "" # Sets the name/id of the nodes that the server creates. Necessary for HA configurations to identify between servers (for instance, netmaker-1, netmaker-2, etc). For non-HA deployments, is not necessary.
          TELEMETRY: "on" # Whether or not to send telemetry data to help improve Netmaker. Switch to "off" to opt out of sending telemetry.
      netmaker-ui: # The Netmaker UI Component
        container_name: netmaker-ui
        depends_on:
          - netmaker
        image: gravitl/netmaker-ui:v0.9.3
        links:
          - "netmaker:api"
        ports:
          - "8082:80"
        environment:
          BACKEND_URL: "http://HOST_IP:8081" # URL where UI will send API requests. Change based on SERVER_HOST, SERVER_HTTP_HOST, and API_PORT
      coredns: # The DNS Server. Remove this section if DNS_MODE="off"
        depends_on:
          - netmaker
        image: coredns/coredns
        command: -conf /root/dnsconfig/Corefile # Config location for Corefile. This is the path of file which is also mounted to Netmaker for modification.
        container_name: coredns
        restart: always
        ports:
          - "53:53/udp" # Likely needs to run at port 53 for adequate nameserver usage.
        volumes:
          - dnsconfig:/root/dnsconfig
    volumes:
      sqldata: {}
      dnsconfig: {}

### Available docker-compose files

The default options for docker-compose can be found here: https://github.com/gravitl/netmaker/tree/master/compose

The following is a brief description of each:

- docker-compose.contained.yml - This is the default docker-compose, used in the quick start and deployment script in the README on GitHub. It deploys Netmaker with all options included (Caddy and CoreDNS) and has “self-contained” netclients, meaning they do not affect host networking.

- docker-compose.coredns.yml - This is a simple compose used to spin up a standalone CoreDNS server. Can be useful if, for instance, you are unning Netmaker on baremetal but need CoreDNS.

- docker-compose.hostnetwork.yml - This is similar to the docker-compose.contained.yml but with a key difference: it has advanced permissions and mounts host volumes to control networking on the host level.

- docker-compose.nocaddy.yml -= This is the same as docker-compose.contained.yml but without Caddy, in case you need to use a different proxy like Nginx, Traefik, or HAProxy.

- docker-compose.nodns.yml - This is the same as docker-compose.contained.yml but without CoreDNS, in which case you will not have the Private DNS feature.

- docker-compose.reference.yml - This is the same as docker-compose.contained.yml but with all variable options on display and annotated (it’s what we show right above this section). Use this to determine which variables you should add or change in your configuration.

- docker-compose.yml - This is a renamed docker-compose.contained.yml. It is meant only to act as a placeholder for what we consider the “primary” docker-compose that users should work with.

## DNS Mode Setup

If you plan on running the server in DNS Mode, know that a CoreDNS Server will be installed. CoreDNS is a light-weight, fast, and easy-to-configure DNS server. It is recommended to bind CoreDNS to port 53 of the host system, and it will do so by default. The clients will expect the nameserver to be on port 53, and many systems have issues resolving a different port.

However, on your host system (for Netmaker), this may conflict with an existing process. On linux systems running systemd-resolved, there is likely a service consuming port 53. The below steps will disable systemd-resolved, and replace it with a generic (e.g. Google) nameserver. Be warned that this may have consequences for any existing private DNS configuration.

With the latest docker-compose, it is not necessary to perform these steps. But if you are running the install and find that port 53 is blocked, you can perform the following steps, which were tested on Ubuntu 20.04 (these should be run prior to deploying the docker containers).

    systemctl stop systemd-resolved
    systemctl disable systemd-resolved
    vim /etc/systemd/resolved.conf
      *  uncomment DNS and add 8.8.8.8 or whatever reachable nameserver is your preference  *
      *  uncomment DNSStubListener and set to "no"  *
    ln -sf /run/systemd/resolve/resolv.conf /etc/resolv.conf

Port 53 should now be available for CoreDNS to use.

## Docker Compose Install

The most simple (and recommended) way of installing Netmaker is to use one of the provided Docker Compose files. Below are instructions for several different options to install Netmaker via Docker Compose, followed by an annotated reference Docker Compose in case your use case requires additional customization.

### Test Install - No DNS, No Secure GRPC

This install will run Netmaker on a server without HTTPS using an IP address. This is not secure and not recommended, but can be helpful for testing.

It also does not run the CoreDNS server, to simplify the deployment

Prerequisites:

  - server ports 80, 8081, and 50051 are not blocked by firewall

Notes:

  - You can change the port mappings in the Docker Compose if the listed ports are already in use.

Assuming you have Docker and Docker Compose installed, you can just run the following, replacing < Insert your-host IP Address Here > with your host IP (or domain):

    wget -O docker-compose.yml https://raw.githubusercontent.com/gravitl/netmaker/master/scripts/docker-compose.test.yml
    sed -i ‘s/HOST_IP/< Insert your-host IP Address Here >/g’ docker-compose.yml
    docker-compose up -d`

### Traefik Proxy

To install with Traefik, rather than Nginx or the default Caddy, check out this repo: https://github.com/bsherman/netmaker-traefik

### No DNS - CoreDNS Disabled

DNS Mode is currently limited to clients that can run resolvectl (systemd-resolved, see Architecture docs for more info). You may wish to disable DNS mode for various reasons. This installation option gives you the full feature set minus CoreDNS.

To run without DNS, follow the Quick Install guide, omitting the steps for DNS setup. In addition, when the guide has you pull (wget) the Netmaker docker-compose template, use the following link instead:

1. `wget -O docker-compose.yml https://raw.githubusercontent.com/gravitl/netmaker/master/scripts/docker-compose.nodns.yml`

This template is equivalent but omits CoreDNS.

## Linux Install without Docker

Most systems support Docker, but some do not. In such environments, there are many options for installing Netmaker. Netmaker is available as a binary file, and there is a zip file of the Netmaker UI static HTML on GitHub. Beyond the UI and Server, you may want to optionally install a database (sqlite is embedded, rqlite or postgres are supported) and CoreDNS (also optional).

Once this is enabled and configured for a domain, you can continue with the below. The recommended server runs Ubuntu 20.04.

### Database Setup (optional)

You can run the netmaker binary standalone and it will run an embedded sqlite server. Data goes in the data/ directory. Optionally, you can run PostgreSQL or rqlite. Instructions for rqlite are below.

1. Install rqlite on your server: https://github.com/rqlite/rqlite

2. Run rqlite: rqlited -node-id 1 ~/node.1

If using rqlite or postgres, you must change the DATABASE environment/config variable and enter connection details.

### Server Setup

1. Run the install script:

`sudo curl -sfL https://raw.githubusercontent.com/gravitl/netmaker/master/scripts/netmaker-server.sh | sh -`

2. Check status: `sudo journalctl -u netmaker`

3. If any settings are incorrect such as host or mongo credentials, change them under /etc/netmaker/config/environments/< your env >.yaml and then run `sudo systemctl restart netmaker`

### UI Setup

The following uses Nginx as an http server. You may alternatively use Apache or any other web server that serves static web files.

1. Download and Unzip UI asset files

2. Copy Config to Nginx

3. Modify Default Config Path

4. Change Backend URL

5. Start Nginx

    sudo wget -O /usr/share/nginx/html/netmaker-ui.zip https://github.com/gravitl/netmaker-ui/releases/download/latest/netmaker-ui.zip
    sudo unzip /usr/share/nginx/html/netmaker-ui.zip -d /usr/share/nginx/html
    sudo cp /usr/share/nginx/html/nginx.conf /etc/nginx/conf.d/default.conf
    sudo sed -i 's/root \/var\/www\/html/root \/usr\/share\/nginx\/html/g' /etc/nginx/sites-available/default
    sudo sh -c 'BACKEND_URL=http://<YOUR BACKEND API URL>:PORT /usr/share/nginx/html/generate_config_js.sh >/usr/share/nginx/html/config.js'
    sudo systemctl start nginx

### CoreDNS Setup (optional)

CoreDNS is only required if you want private DNS features. Once installed, you must set the CoreDNS variables in the env settings of the server.

See https://coredns.io/manual/toc/#installation

### Proxy / Load Balancer

You will need to proxy connections to your UI and Server. By default the ports are 8081, 8082, and 50051 (grpc). This proxy should handle SSL certificates. We recommend Caddy or Nginx (you can follow the Nginx guide in these docs). The proxy must be able to handle gRPC connections.

## Kubernetes Install

### Server Install

This template assumes your cluster uses Nginx for ingress with valid wildcard certificates. If using an ingress controller other than Nginx (ex: Traefik), you will need to manually modify the Ingress entries in this template to match your environment.

This template also requires RWX storage. Please change references to storageClassName in this template to your cluster’s Storage Class.

`wget https://raw.githubusercontent.com/gravitl/netmaker/master/kube/netmaker-template.yaml`

Replace the NETMAKER_BASE_DOMAIN references to the base domain you would like for your Netmaker services (ui,api,grpc). Typically this will be something like netmaker.yourwildcard.com.

`sed -i ‘s/NETMAKER_BASE_DOMAIN/<your base domain>/g’ netmaker-template.yaml`

Now, assuming Ingress and Storage match correctly with your cluster configuration, you can install Netmaker.

    kubectl create ns nm
    kubectl config set-context --current --namespace=nm
    kubectl apply -f netmaker-template.yaml -n nm

In about 3 minutes, everything should be up and running:

`kubectl get ingress nm-ui-ingress-nginx`

### Netclient Daemonset

The following instructions assume you have Netmaker running and a network you would like to add your cluster into. The Netmaker server does not need to be running inside of a cluster for this.

    wget https://raw.githubusercontent.com/gravitl/netmaker/master/kube/netclient-template.yaml
    sed -i ‘s/ACCESS_TOKEN_VALUE/< your access token value>/g’ netclient-template.yaml
    kubectl apply -f netclient-template.yaml

For a more detailed guide on integrating Netmaker with MicroK8s, check out this guide.

## Nginx Reverse Proxy Setup with https

The Swag Proxy makes it easy to generate a valid ssl certificate for the config bellow. Here is the documentation for the installation.

The following file configures Netmaker as a subdomain. This config is an adaption from the swag proxy project.

./netmaker.subdomain.conf:

    server {
        listen 443 ssl;
        listen [::]:443 ssl;

        server_name netmaker.*; # The external URL
        client_max_body_size 0;

        # A valid https certificate is needed.
        include /config/nginx/ssl.conf;

        location / {
            # This config file can be found at:
            # https://github.com/linuxserver/docker-swag/blob/master/root/defaults/proxy.conf
            include /config/nginx/proxy.conf;

            # if you use a custom resolver to find your app, needed with swag proxy
            # resolver 127.0.0.11 valid=30s;
            set $upstream_app netmaker-ui;                             # The internal URL
            set $upstream_port 80;                                     # The internal Port
            set $upstream_proto http;                                  # the protocol that is being used
            proxy_pass $upstream_proto://$upstream_app:$upstream_port; # combine the set variables from above
            }
        }

    server {
        listen 443 ssl;
        listen [::]:443 ssl;

        server_name backend-netmaker.*; # The external URL
        client_max_body_size 0;
        underscores_in_headers on;

        # A valid https certificate is needed.
        include /config/nginx/ssl.conf;

        location / {
            # if you use a custom resolver to find your app, needed with swag proxy
            # resolver 127.0.0.11 valid=30s;

            set $upstream_app netmaker;                                # The internal URL
            set $upstream_port 8081;                                   # The internal Port
            set $upstream_proto http;                                  # the protocol that is being used
            proxy_pass $upstream_proto://$upstream_app:$upstream_port; # combine the set variables from above

            # Forces the header to be the one that is visible from the outside
            proxy_set_header                Host backend.netmaker.example.org; # Please cange to your URL

            # Pass all headers through to the backend
            proxy_pass_request_headers      on;
            }
        }

## Highly Available Installation (Kubernetes)

Netmaker comes with a Helm chart to deploy with High Availability on Kubernetes:

    helm repo add netmaker https://gravitl.github.io/netmaker-helm/
    helm repo update

### Requirements

To run HA Netmaker on Kubernetes, your cluster must have the following: - RWO and RWX Storage Classes (RWX is only required if running Netmaker with DNS Management enabled). - An Ingress Controller and valid TLS certificates - This chart can currently generate ingress for Nginx or Traefik Ingress with LetsEncrypt + Cert Manager - If LetsEncrypt and CertManager are not deployed, you must manually configure certificates for your ingress

Furthermore, the chart will by default install and use a postgresql cluster as its datastore.

### Recommended Settings:

A minimal HA install of Netmaker can be run with the following command: helm install netmaker –generate-name –set baseDomain=nm.example.com This install has some notable exceptions: - Ingress must be manually configured post-install (need to create valid Ingress with TLS) - Server will use “userspace” WireGuard, which is slower than kernel WG - DNS will be disabled

### Example Installations:

An annotated install command:

    helm install netmaker/netmaker --generate-name \ # generate a random id for the deploy
    --set baseDomain=nm.example.com \ # the base wildcard domain to use for the netmaker api/dashboard/grpc ingress
    --set replicas=3 \ # number of server replicas to deploy (3 by default)
    --set ingress.enabled=true \ # deploy ingress automatically (requires nginx or traefik and cert-manager + letsencrypt)
    --set ingress.className=nginx \ # ingress class to use
    --set ingress.tls.issuerName=letsencrypt-prod \ # LetsEncrypt certificate issuer to use
    --set dns.enabled=true \ # deploy and enable private DNS management with CoreDNS
    --set dns.clusterIP=10.245.75.75 --set dns.RWX.storageClassName=nfs \ # required fields for DNS
    --set postgresql-ha.postgresql.replicaCount=2 \ # number of DB replicas to deploy (default 2)

The below command will install netmaker with two server replicas, a coredns server, and ingress with routes of api.nm.example.com, grpc.nm.example.com, and dashboard.nm.example.com. CoreDNS will be reachable at 10.245.75.75, and will use NFS to share a volume with Netmaker (to configure dns entries).

    helm install netmaker/netmaker --generate-name --set baseDomain=nm.example.com \
    --set replicas=2 --set ingress.enabled=true --set dns.enabled=true \
    --set dns.clusterIP=10.245.75.75 --set dns.RWX.storageClassName=nfs \
    --set ingress.className=nginx

The below command will install netmaker with three server replicas (the default), no coredns, and ingress with routes of api.netmaker.example.com, grpc.netmaker.example.com, and dashboard.netmaker.example.com. There will be one UI replica instead of two, and one database instance instead of two. Traefik will look for a ClusterIssuer named “le-prod-2” to get valid certificates for the ingress.

    helm3 install netmaker/netmaker --generate-name \
    --set baseDomain=netmaker.example.com --set postgresql-ha.postgresql.replicaCount=1 \
    --set ui.replicas=1 --set ingress.enabled=true \
    --set ingress.tls.issuerName=le-prod-2 --set ingress.className=traefik

Below, we discuss the considerations for Ingress, Kernel WireGuard, and DNS.

### Ingress

To run HA Netmaker, you must have ingress installed and enabled on your cluster with valid TLS certificates (not self-signed). If you are running Nginx as your Ingress Controller and LetsEncrypt for TLS certificate management, you can run the helm install with the following settings:

- –set ingress.enabled=true

- –set ingress.annotations.cert-manager.io/cluster-issuer=<your LE issuer name>

If you are not using Nginx or Traefik and LetsEncrypt, we recommend leaving ingress.enabled=false (default), and then manually creating the ingress objects post-install. You will need three ingress objects with TLS:

- dashboard.<baseDomain>

- api.<baseDomain>

- grpc.<baseDomain>

If deploying manually, the gRPC ingress object requires special considerations. Look up the proper way to route grpc with your ingress controller. For instance, on Traefik, an IngressRouteTCP object is required.

There are some example ingress objects in the kube/example folder.

### Kernel WireGuard

If you have control of the Kubernetes worker node servers, we recommend first installing WireGuard on the hosts, and then installing HA Netmaker in Kernel mode. By default, Netmaker will install with userspace WireGuard (wireguard-go) for maximum compatibility, and to avoid needing permissions at the host level. If you have installed WireGuard on your hosts, you should install Netmaker’s helm chart with the following option:

- –set wireguard.kernel=true

### DNS

By Default, the helm chart will deploy without DNS enabled. To enable DNS, specify with:

- –set dns.enabled=true

This will require specifying a RWX storage class, e.g.:

- –set dns.RWX.storageClassName=nfs

This will also require specifying a service address for DNS. Choose a valid ipv4 address from the service IP CIDR for your cluster, e.g.:

- –set dns.clusterIP=10.245.69.69

This address will only be reachable from hosts that have access to the cluster service CIDR. It is only designed for use cases related to k8s. If you want a more general-use Netmaker server on Kubernetes for use cases outside of k8s, you will need to do one of the following: - bind the CoreDNS service to port 53 on one of your worker nodes and set the COREDNS_ADDRESS equal to the public IP of the worker node - Create a private Network with Netmaker and set the COREDNS_ADDRESS equal to the private address of the host running CoreDNS. For this, CoreDNS will need a node selector and will ideally run on the same host as one of the Netmaker server instances.

### Values

To view all options for the chart, please visit the README in the code repo here .

## Highly Available Installation (VMs/Bare Metal)

For an enterprise Netmaker installation, you will need a server that is highly available, to ensure redundant WireGuard routing when any server goes down. To do this, you will need:

1. A load balancer

2. 3+ Netmaker server instances

3. rqlite or PostgreSQL as the backing database

These documents outline general HA installation guidelines. Netmaker is highly customizable to meet a wide range of enterprise environments. If you would like support with an enterprise-grade Netmaker installation, you can schedule a consultation here .

The main consideration for this document is how to configure rqlite. Most other settings and procedures match the standardized way of making applications HA: Load balancing to multiple instances, and sharing a DB. In our case, the DB (rqlite) is distributed, making HA data more easily achievable.

If using PostgreSQL, follow their documentation for installing in HA mode and skip step #2.

### 1. Load Balancer Setup

Your load balancer of choice will send requests to the Netmaker servers. Setup is similar to the various guides we have created for Nginx, Caddy, and Traefik. SSL certificates must also be configured and handled by the LB.

### 2. RQLite Setup

RQLite is the included distributed datastore for an HA Netmaker installation. If you have a different corporate database you wish to integrate, Netmaker is easily extended to other DB’s. If this is a requirement, please contact us.

Assuming you use Rqlite, you must run it on each Netmaker server VM, or alongside that VM as a container. Setup a config.json for database credentials (password supports BCRYPT HASHING) and mount in working directory of rqlite and specify with -auth config.json :

    [{
        "username": "netmaker",
        "password": "<YOUR_DB_PASSWORD>",
        "perms": ["all"]
    }]

Once your servers are set up with rqlite, the first instance must be started normally, and then additional nodes must be added with the “join” command. For instance, here is the first server node:

    sudo docker run -d -p 4001:4001 -p 4002:4002 rqlite/rqlite -node-id 1 -http-addr 0.0.0.0:4001 -raft-addr 0.0.0.0:4002 -http-adv-addr 1.2.3.4:4001 -raft-adv-addr 1.2.3.4:4002 -auth config.json

And here is a joining node:

    sudo docker run -d -p 4001:4001 -p 4002:4002 rqlite/rqlite -node-id 2 -http-addr 0.0.0.0:4001 -raft-addr 0.0.0.0:4002 -http-adv-addr 2.3.4.5:4001  -raft-adv-addr 2.3.4.5:4002 -join https://netmaker:<YOUR_DB_PASSWORD>@1.2.3.4:4001

- reference for rqlite setup: https://github.com/rqlite/rqlite/blob/master/DOC/CLUSTER_MGMT.md#creating-a-cluster

- reference for rqlite security: https://github.com/rqlite/rqlite/blob/master/DOC/SECURITY.md

Once rqlite instances have been configured, the Netmaker servers can be deployed.

### 3. Netmaker Setup

Netmaker will be started on each node with default settings, except with DATABASE=rqlite (or DATABASE=postgress) and SQL_CONN set appropriately to reach the local rqlite instance. Rqlite will maintain consistency with each Netmaker backend.

If deploying HA with PostgreSQL, you will connect with the following settings:

    SQL_HOST = <sql host>
    SQL_PORT = <port>
    SQL_DB   = <designated sql DB>
    SQL_USER = <your user>
    SQL_PASS = <your password>
    DATABASE = postgres

### 4. Other Considerations

This is enough to get a functioning HA installation of Netmaker. However, you may also want to make the Netmaker UI or the CoreDNS server HA as well. The Netmaker UI can simply be added to the same servers and load balanced appropriately. For some load balancers, you may be able to do this with CoreDNS as well.